/*                                                                |- Impulse -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is the Impulse utility library
 * for Impulse. (Part of the ROWS distribution)
 *
 * The Initial Developer of the Original Code is
 * Daniel Berrange. Portions created by Daniel Berrange
 * are Copyright (C) 1999 Daniel Berrange.
 * All Rights Reserved
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * link.h
 * ---------
 *
 * Communication link functions
 */


#ifndef __impulse_comms_link_h
#define __impulse_comms_link_h

#include <impulse/comms/channel.h>
#include <impulse/comms/message.h>

struct _impulse_link
{
  impulse_channel channel;
  impulse_int byteorder;
  
  impulse_unistring name;
  impulse_unistring release;
  impulse_unistring vendor;
  impulse_unistring platform;
  impulse_unistring architecture;
  
  void *internal;
};

typedef struct _impulse_link *impulse_link;

impulse_link impulse_link_create(impulse_channel channel);
void impulse_link_destroy(impulse_link chan);

impulse_int impulse_link_pending(impulse_link chan);
impulse_int impulse_link_send(impulse_link chan,
				 impulse_message out);
impulse_int impulse_link_receive(impulse_link chan,
				    impulse_message *in);

#endif

/* End of file */
