/*                                                                  |- CFSFC -|
 * The contents of this file are subject to the Mozilla
 * Public License Version 1.0 (the "License"); you may
 * not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 *
 * Software distributed under the License is distributed
 * on an "AS IS" basis, WITHOUT WARRANTY OF
 * ANY KIND, either express or implied. See the
 * License for the specific language governing rights
 * and limitations under the License. 
 *
 * The Original Code is Copyright (C) 1998 Andrew Hunter.
 * All Rights Reserved. 
 *
 * The Initial Developer of the Original Code is
 * Andrew Hunter.
 *
 * Contributor(s):
 * No-one (yet :-)
 */

/*
 * container_int.h
 * ---------------
 *
 * Container widget internal information
 */

#ifndef __impulse_rows_container_int_h
#define __impulse_rows_container_int_h

#include <impulse/rows/container.h>

typedef struct _ROWS_container_child {
  ROWS_child child;
  int padding;
  int flags;
  void *data;

  struct _ROWS_container_child *next;
} ROWS_container_child;


typedef struct {
  ROWS_container_child *children;

  ROWS_child mouse_contained;
  ROWS_child mouse_grabbed;
  impulse_bool mouse_grab;
  impulse_bool mouse_ignore;
  
} _p_ROWS_container_data;

typedef void (*ROWS_container_iter)(ROWS_container container,
				    ROWS_child child,
				    void *data,
				    void *moredata);

/* Functions */

extern impulse_inline void  ROWS_container_add_int(ROWS_container container,
						   ROWS_child child,
						   void *data);
extern impulse_inline void  *ROWS_container_remove_int(ROWS_container container,
						       ROWS_child     child);
extern void *ROWS_container_lookup_int(ROWS_container container,
				       ROWS_child child);

extern inline void  ROWS_container_iter_int(ROWS_container container,
					    ROWS_container_iter function,
					    void *moredata);

#endif
